searchNodes=[{"ref":"Chapters.html","title":"Chapters","module":"Chapters","type":"module","doc":"Podcast chapter parser and formatter. Supports: Podlove Simple Chapters (xml/psc) mp4chaps JSON Changelog Basic Usage Decode from mp4chaps iex(1)&gt; chapters = Chapters.decode(~S&quot;&quot;&quot; ...(1)&gt; 00:00:00 Intro ...(1)&gt; 00:01:59 Podlove &lt;http://podlove.org/&gt; ...(1)&gt; &quot;&quot;&quot;, :mp4chaps) [ %Chapters.Chapter{href: nil, image: nil, start: 0, title: &quot;Intro&quot;}, %Chapters.Chapter{ href: &quot;http://podlove.org/&quot;, image: nil, start: 119000, title: &quot;Podlove&quot; } ] Encode to PSC iex&gt; Chapters.encode(chapters, :psc) |&gt; IO.puts &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;psc:chapters version=&quot;1.2&quot; xmlns:psc=&quot;http://podlove.org/simple-chapters&quot;&gt; &lt;psc:chapter start=&quot;00:00:00.000&quot; title=&quot;Intro&quot;/&gt; &lt;psc:chapter start=&quot;00:01:59.000&quot; title=&quot;Podlove&quot; href=&quot;http://podlove.org/&quot;/&gt; &lt;/psc:chapters&gt; Encode to mp4chaps iex&gt; Chapters.encode(chapters, :mp4chaps) |&gt; IO.puts 00:00:00.000 Intro 00:01:59.000 Podlove &lt;http://podlove.org/&gt; Encode to JSON iex&gt; Chapters.encode(chapters, :json) |&gt; IO.puts [{&quot;start&quot;:&quot;00:00:00.000&quot;,&quot;title&quot;:&quot;Intro&quot;},{&quot;start&quot;:&quot;00:01:59.000&quot;,&quot;title&quot;:&quot;Podlove&quot;,&quot;href&quot;:&quot;http://podlove.org/&quot;}]"},{"ref":"Chapters.html#decode/2","title":"Chapters.decode/2","module":"Chapters","type":"function","doc":"Decode podcast chapter binary. Supported formats: :psc, :mp4chaps, :json"},{"ref":"Chapters.html#encode/2","title":"Chapters.encode/2","module":"Chapters","type":"function","doc":"Encode podcast chapter object into binary. Supported formats: :psc, :mp4chaps, :json"},{"ref":"Chapters.html#t:chapter_format/0","title":"Chapters.chapter_format/0","module":"Chapters","type":"type","doc":""},{"ref":"Chapters.Chapter.html","title":"Chapters.Chapter","module":"Chapters.Chapter","type":"module","doc":"One chapter entry."},{"ref":"Chapters.Chapter.html#sanitize/1","title":"Chapters.Chapter.sanitize/1","module":"Chapters.Chapter","type":"function","doc":"Sanitizes the href and image values. Trims them and nils them out if they are an empty string. iex&gt; %Chapters.Chapter{href: &quot; //foo &quot;, image: &quot; &quot;, start: 0, title: &quot;Title&quot;} |&gt; Chapter.sanitize() %Chapters.Chapter{href: &quot;//foo&quot;, image: nil, start: 0, title: &quot;Title&quot;} iex&gt; %Chapters.Chapter{href: &quot; &quot;, image: &quot; &quot;, start: 0, title: &quot;Title&quot;} |&gt; Chapter.sanitize() %Chapters.Chapter{href: nil, image: nil, start: 0, title: &quot;Title&quot;}"},{"ref":"Chapters.Chapter.html#to_keylist/1","title":"Chapters.Chapter.to_keylist/1","module":"Chapters.Chapter","type":"function","doc":"Produces an ordered keylist :start, :title, :href, :image with the start already formatted top a normal playtime for use in output formats iex&gt; %Chapters.Chapter{href: &quot;//foo&quot;, image: nil, start: 1234, title: &quot;Title&quot;} |&gt; Chapter.to_keylist() [start: &quot;00:00:01.234&quot;, title: &quot;Title&quot;, href: &quot;//foo&quot;] iex&gt; %Chapters.Chapter{href: &quot;&quot;, image: &quot;//foo.jpeg&quot;, start: 1234, title: &quot;Title&quot;} |&gt; Chapter.to_keylist() [start: &quot;00:00:01.234&quot;, title: &quot;Title&quot;, image: &quot;//foo.jpeg&quot;]"},{"ref":"Chapters.Chapter.html#t:t/0","title":"Chapters.Chapter.t/0","module":"Chapters.Chapter","type":"type","doc":"start - milliseconds since start. e.g. &quot;00:01:30.000&quot; would be 90_000 (mandatory) title - title of that chapter (mandatory) href - link to jump to that chapter (optional) image - url to a chapter image (optional)"},{"ref":"Chapters.Formatters.Normalplaytime.Formatter.html","title":"Chapters.Formatters.Normalplaytime.Formatter","module":"Chapters.Formatters.Normalplaytime.Formatter","type":"module","doc":""},{"ref":"Chapters.Formatters.Normalplaytime.Formatter.html#format/1","title":"Chapters.Formatters.Normalplaytime.Formatter.format/1","module":"Chapters.Formatters.Normalplaytime.Formatter","type":"function","doc":"Format milliseconds to a normal playtime string Examples iex&gt; format(2_511_792) &quot;00:41:51.792&quot;"},{"ref":"Chapters.Parsers.Mp4chaps.Parser.html","title":"Chapters.Parsers.Mp4chaps.Parser","module":"Chapters.Parsers.Mp4chaps.Parser","type":"module","doc":"Mp4chaps parser. Examples iex&gt; {:ok, [r | _], &quot;&quot;, _, _, _} = mp4chaps(&quot;00:00:00 Intro&quot;) iex&gt; r [start: [hours: 0, minutes: 0, seconds: 0], title: &quot;Intro&quot;] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = mp4chaps(&quot;00:00:00 Intro\\r\\n00:01:02 Podlove &lt;https://podlove.org&gt;&quot;) iex&gt; r [ [start: [hours: 0, minutes: 0, seconds: 0], title: &quot;Intro&quot;], [start: [hours: 0, minutes: 1, seconds: 2], title: &quot;Podlove&quot;, href: &quot;https://podlove.org&quot;] ]"},{"ref":"Chapters.Parsers.Mp4chaps.Parser.html#mp4chaps/2","title":"Chapters.Parsers.Mp4chaps.Parser.mp4chaps/2","module":"Chapters.Parsers.Mp4chaps.Parser","type":"function","doc":"Parses the given binary as mp4chaps. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the mp4chaps (start position) as {line, column_on_line}. Options :line - the initial line, defaults to 1 :byte_offset - the initial byte offset, defaults to 0 :context - the initial context value. It will be converted to a map"},{"ref":"Chapters.Parsers.Mp4chaps.Parser.html#parse/1","title":"Chapters.Parsers.Mp4chaps.Parser.parse/1","module":"Chapters.Parsers.Mp4chaps.Parser","type":"function","doc":""},{"ref":"Chapters.Parsers.Normalplaytime.Parser.html","title":"Chapters.Parsers.Normalplaytime.Parser","module":"Chapters.Parsers.Normalplaytime.Parser","type":"module","doc":"Parses Normal Play Time strings. See https://www.w3.org/TR/media-frags/#npttimedef. Examples iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;1&quot;) iex&gt; r [{:seconds, 1}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;1.843&quot;) iex&gt; r [{:seconds, 1}, {:milliseconds, 843}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;12:34&quot;) iex&gt; r [{:minutes, 12}, {:seconds, 34}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;12:34.56&quot;) iex&gt; r [{:minutes, 12}, {:seconds, 34}, {:milliseconds, 560}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;12:34.5&quot;) iex&gt; r [{:minutes, 12}, {:seconds, 34}, {:milliseconds, 500}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;1:2&quot;) iex&gt; r [{:minutes, 1}, {:seconds, 2}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;1:2:3.4&quot;) iex&gt; r [{:hours, 1}, {:minutes, 2}, {:seconds, 3}, {:milliseconds, 400}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;01:02:03&quot;) iex&gt; r [{:hours, 1}, {:minutes, 2}, {:seconds, 3}] iex&gt; {:ok, r, &quot;&quot;, _, _, _} = parse(&quot;00:00:00.123&quot;) iex&gt; r [{:hours, 0}, {:minutes, 0}, {:seconds, 0}, {:milliseconds, 123}]"},{"ref":"Chapters.Parsers.Normalplaytime.Parser.html#convert_ms/1","title":"Chapters.Parsers.Normalplaytime.Parser.convert_ms/1","module":"Chapters.Parsers.Normalplaytime.Parser","type":"function","doc":""},{"ref":"Chapters.Parsers.Normalplaytime.Parser.html#parse/2","title":"Chapters.Parsers.Normalplaytime.Parser.parse/2","module":"Chapters.Parsers.Normalplaytime.Parser","type":"function","doc":"Parses the given binary as parse. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the parse (start position) as {line, column_on_line}. Options :line - the initial line, defaults to 1 :byte_offset - the initial byte offset, defaults to 0 :context - the initial context value. It will be converted to a map"},{"ref":"Chapters.Parsers.Normalplaytime.Parser.html#parse_total_ms/1","title":"Chapters.Parsers.Normalplaytime.Parser.parse_total_ms/1","module":"Chapters.Parsers.Normalplaytime.Parser","type":"function","doc":"Get total milliseconds from a Normal Play Time string. See https://www.w3.org/TR/media-frags/#npttimedef. Examples iex&gt; parse_total_ms(&quot;00:01:30.00&quot;) 90000 iex&gt; parse_total_ms(&quot;something&quot;) nil"},{"ref":"Chapters.Parsers.Normalplaytime.Parser.html#total_ms/1","title":"Chapters.Parsers.Normalplaytime.Parser.total_ms/1","module":"Chapters.Parsers.Normalplaytime.Parser","type":"function","doc":"Get total milliseconds from parse result. Examples iex&gt; total_ms [{:hours, 1}, {:minutes, 2}, {:seconds, 3}, {:milliseconds, 400}] 3723400"},{"ref":"readme.html","title":"Chapters","module":"readme","type":"extras","doc":"Chapters Online Documentation. Github Changelog Podcast chapter parser and formatter. Supports: Podlove Simple Chapters (xml/psc) mp4chaps JSON Changelog"},{"ref":"readme.html#basic-usage","title":"Chapters - Basic Usage","module":"readme","type":"extras","doc":"Decode from mp4chaps iex(1)&gt; chapters = Chapters.decode(~S&quot;&quot;&quot; ...(1)&gt; 00:00:00 Intro ...(1)&gt; 00:01:59 Podlove &lt;http://podlove.org/&gt; ...(1)&gt; &quot;&quot;&quot;, :mp4chaps) [ %Chapters.Chapter{href: nil, image: nil, start: 0, title: &quot;Intro&quot;}, %Chapters.Chapter{ href: &quot;http://podlove.org/&quot;, image: nil, start: 119000, title: &quot;Podlove&quot; } ] Encode to PSC iex&gt; Chapters.encode(chapters, :psc) |&gt; IO.puts &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;psc:chapters version=&quot;1.2&quot; xmlns:psc=&quot;http://podlove.org/simple-chapters&quot;&gt; &lt;psc:chapter start=&quot;00:00:00.000&quot; title=&quot;Intro&quot;/&gt; &lt;psc:chapter start=&quot;00:01:59.000&quot; title=&quot;Podlove&quot; href=&quot;http://podlove.org/&quot;/&gt; &lt;/psc:chapters&gt; Encode to mp4chaps iex&gt; Chapters.encode(chapters, :mp4chaps) |&gt; IO.puts 00:00:00.000 Intro 00:01:59.000 Podlove &lt;http://podlove.org/&gt; Encode to JSON iex&gt; Chapters.encode(chapters, :json) |&gt; IO.puts [{&quot;start&quot;:&quot;00:00:00.000&quot;,&quot;title&quot;:&quot;Intro&quot;},{&quot;start&quot;:&quot;00:01:59.000&quot;,&quot;title&quot;:&quot;Podlove&quot;,&quot;href&quot;:&quot;http://podlove.org/&quot;}]"},{"ref":"readme.html#installation","title":"Chapters - Installation","module":"readme","type":"extras","doc":"The package can be installed by adding chapters to your list of dependencies in mix.exs: def deps do [ {:chapters, &quot;~&gt; 1.0&quot;} ] end"},{"ref":"readme.html#license","title":"Chapters - License","module":"readme","type":"extras","doc":"Chapters is MIT Licensed."},{"ref":"changelog.html","title":"Changelog","module":"changelog","type":"extras","doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog, and this project adheres to Semantic Versioning."},{"ref":"changelog.html#1-0-1-2019-07-08","title":"Changelog - 1.0.1 - 2019-07-08","module":"changelog","type":"extras","doc":"Added Chapters.Chapter.sanitize/1 to trim and nil url strings in href and image This CHANGELOG file as standardized open source project CHANGELOG. Changed Use sanitize in export to not produce values with empty strings or whitespace padding."},{"ref":"changelog.html#1-0-0-2019-06-26","title":"Changelog - 1.0.0 - 2019-06-26","module":"changelog","type":"extras","doc":"Added Import and export of image fields from psc and json. Changed Chapters.Chapter type field changes to be more in line with the formats. time→start and url→href. More consise and ordered output. href and img entries are omitted if empty, all formats produce a consistent order of start, title, href, image."},{"ref":"changelog.html#0-1-0-2019-04-02","title":"Changelog - 0.1.0 - 2019-04-02","module":"changelog","type":"extras","doc":"Added Core functionality, parse and export of psc, json and mp4chaps chapter formats."}]